"""

Vortex Racers

  Race clockwork vehicles and other wind-up toys around a track, avoiding
  the tornado.

  Pyweek 5 Scavengers team entry  Sep 2007

  GPL v3 or later


 Coder:
   scav (Peter Harris)

 Graphic Design:
   badgerigar (Paul Harris)

 Tornado Idea:
   Jacqueline Harris

"""
import sys

import logging
import pygame
import data
import gamescreens
import materials

#logging.basicConfig(level=logging.INFO)

def main():
    options = {"key_left":pygame.K_z,
               "key_right":pygame.K_x,
               "key_brake":pygame.K_RSHIFT,
               "slow":False,
                }
    size = (800,600)
    fullscreen=False
    slow=False # slow OpenGL implementation
    fullscreen=('--fullscreen' in sys.argv[1:])
    slow = ('--snow' in sys.argv[1:])
    gamescreens.init(size,fullscreen)

    if slow:
        materials.NOTEXTURES = True
        options["slow"] = True

    materials.load("materials.mtl")
    materials.select("White")
    
    while True:
        choice = gamescreens.run_title_screen()
        if choice == "Options":
            gamescreens.run_option_screen(options)
        elif choice == "Play":
            choice = gamescreens.choose_track(options)
            if choice == "Back":
                continue
            choice = gamescreens.choose_car(options)
            if choice == "Back":
                continue
            choice = gamescreens.choose_colour(options)
            if choice == "Back":
                continue
            gamescreens.run_race(options)
            gamescreens.show_rankings(options)
        elif choice == "Quit":
            break            
