"""
  patches.py

  Nasty patches over broken version of tdlib
"""

import OpenGL.GL as GL
import OpenGL.GLU as GLU
GL.glScale = GL.glScalef  # PyOpenGL 3.0 difference?

import tdlib.lighting

adjust_light = tdlib.lighting.adjust_light

def light_colour_fix(lightnum,colour,steps=0):
    acolour = tuple(c * 0.1 for c in colour)
    adjust_light(lightnum,GL.GL_AMBIENT,acolour,steps)
    adjust_light(lightnum,GL.GL_SPECULAR,colour,steps)
    adjust_light(lightnum,GL.GL_DIFFUSE,colour,steps)

def release_light_fix(light):
    """Release a light so it can be used for other things"""
    if light in tdlib.lighting.claimed_lights:
        tdlib.lighting.light_switch(light,False)
        tdlib.lighting.claimed_lights.remove(light)
        tdlib.lighting.free_lights.append(light)
    
tdlib.lighting.light_colour = light_colour_fix
tdlib.lighting.release_light = release_light_fix

import tdlib.picking

def project_fix():
    GL.glMatrixMode(GL.GL_PROJECTION)
    GL.glLoadIdentity()
    if tdlib.picking.active:
        x,y,dx,dy = tdlib.picking.pickRect
        vport = GL.glGetIntegerv(GL.GL_VIEWPORT)
        GLU.gluPickMatrix(x,y,dx,dy,vport)

tdlib.picking.project = project_fix
