""" QAtype metaclass - makes sure class obeys picky QA rules

"""
import warnings

class QAtype(type):
    """QAtype is a metaclass that performs picky consistency or policy
    checks on classes it is used to build."""
    def __init__(cls,name, bases, members):
        """Create a type, but do some QA checks (e.g. docstring
        must be nonempty"""
        for n, ob in members.items():
            if hasattr(ob,'__doc__') and not ob.__doc__:
                warnings.warn("%s.%s needs a doc string" % (name,n))
        return type(name,bases,members)
